﻿module FallingCrusherModule		

using ..Ahorn, Maple

@mapdef Entity "altlevelshelper/fallingblock" FallingCrusher(x::Integer, y::Integer, width::Integer=Maple.defaultBlockWidth, height::Integer=Maple.defaultBlockHeight,
	SpeedPerSecond::Number=200.0, tiletype::String="3")

const placements = Ahorn.PlacementDict(
    "Falling Crusher (Alt Levels Helper)" => Ahorn.EntityPlacement(
        FallingCrusher,
        "rectangle",
        Dict{String, Any}(),
        function(entity)
            Ahorn.tileEntityFinalizer(entity)
        end,
    ),
)

Ahorn.editingOptions(entity::FallingCrusher) = Dict{String, Any}(
    "tiletype" => Ahorn.tiletypeEditingOptions()
)

# The Intro Crusher functionality only works if the entity is >= 22 wide
# Ahorn.minimumSize(entity::FallingCrusher) = 24, 8
# The Falling Crusher functionality always works and doesn't give a shit about how wide is it
Ahorn.resizable(entity::FallingCrusher) = true, true

function Ahorn.selection(entity::FallingCrusher)
    x, y = Ahorn.position(entity)

    width = Int(get(entity.data, "width", 8))
    height = Int(get(entity.data, "height", 8))

    return [Ahorn.Rectangle(x, y, width, height)]
end

Ahorn.renderAbs(ctx::Ahorn.Cairo.CairoContext, entity::FallingCrusher, room::Maple.Room) = Ahorn.drawTileEntity(ctx, room, entity, blendIn=false)

function Ahorn.renderSelectedAbs(ctx::Ahorn.Cairo.CairoContext, entity::FallingCrusher, room::Maple.Room)
    x, y = Ahorn.position(entity)

    width = Int(get(entity.data, "width", 8))
    height = Int(get(entity.data, "height", 8))
end

end