﻿module PortalCreator

using ..Ahorn, Maple

@mapdef Trigger "altlevelshelper/portaltrigger" PortalCreatorTrigger(x::Integer, y::Integer, width::Integer=16, height::Integer=16,
movePlayer::Bool=false, portalX::Number=0.0, portalY::Number=0.0, destinationX::Number=0.0, destinationY::Number=0.0, enterAnimation::String="None",
levelType::String="Normal", levelNumber::Integer=0, roomName::String="a-00", creationDelay::Number=0)

const placements = Ahorn.PlacementDict(
    "Create Portal Trigger (Alt Levels Helper)" => Ahorn.EntityPlacement(
        PortalCreatorTrigger,
        "rectangle"
    )
)

const enterings = String[
	"Transition",
	"Respawn",
	"WalkInRight",
	"WalkInLeft",
	"Jump",
	"WakeUp",
	"Fall",
	"TempleMirrorVoid",
	"None",
	"ThinkForABit"
]

const lvltypes = String[
    "Normal",
    "BSide",
	"CSide"
]

function Ahorn.editingOptions(trigger::PortalCreatorTrigger)
    return Dict{String, Any}(
        "enterAnimation" => enterings,
		"levelType" => lvltypes
    )
end

end